#include <windows.h>
#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <iostream.h>
#include "ntree.hpp"
#include "matrix.hpp"
#include "jTimer.h"

#define KEY_ST     0
#define KEY_SP     256
#define KEY_DOWN   512
#define KEY_MODIFY 256*4
#define KEY_left   KEY_SP+100
#define KEY_right  KEY_SP+102
#define KEY_up     KEY_SP+101
#define KEY_down   KEY_SP+103

#define FRUSTUM    3000

int frame_w2;
int frame_h2;

float dt,dt2,ferry;
matrix<float> project(4,4,"");
matrix<int> keys(256,6,"");
int mouse[7];
bool fscreen=false,modes[4];
array<unsigned char> *fnt0; //courier 7x11 bold
static int shot_cnt=0,tri_cnt=0;

#include "jglLabel.hpp"
glLabel glCout;

void main_ (int argc,char** argv);
void display_ (void);

void display(void) {
  int c1;
	char dtc[20];
	glClear(GL_DEPTH_BUFFER_BIT);	
  dt=timer::singleton()->resetTime(1)*.001;	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	glDisable(GL_BLEND);
	glMatrixMode(GL_PROJECTION);	
	glPushMatrix();
		glLoadIdentity();		
		gluOrtho2D(0,frame_w,0,frame_h);
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();		
			glLoadIdentity();			
	
	for (c1=0;c1<20;c1++)
	  display_();		
	  
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
	glPopMatrix();	
	glMatrixMode(GL_MODELVIEW);
	glDisable(GL_BLEND);
	  
	sprintf(dtc,"%4.1f ",ferry);
	linked_label.append(new glLabelText(0,0,dtc,fnt0));	
	glCout.flush();
	if (keys.data[27]) exit(0);
	if (keys.data[103]) { //opengl control mode
		if (keys.data[102+KEY_DOWN]) //flat shade
			if (modes[1]) {
  			modes[1]=false;
  			glShadeModel(GL_SMOOTH);
  		} else {
    		modes[1]=true;
    		glShadeModel(GL_FLAT);
    	}
		if (keys.data[115+KEY_DOWN]) {//saving
			int size[3];
			size[0]=4; size[1]=frame_w; size[2]=frame_h;
			array<unsigned char> rgba(3,size,0);
			glReadPixels(0,0,frame_w,frame_h,GL_RGBA,GL_UNSIGNED_BYTE,rgba.data);
			char fnc[60];
			sprintf(fnc,"data/pixels%i.rgba",shot_cnt); rgba.store(fnc);
			array<float> depth(2,&size[1],0);
			glReadPixels(0,0,frame_w,frame_h,GL_DEPTH_COMPONENT,GL_FLOAT,depth.data);
			sprintf(fnc,"data/pixels%i.depth",shot_cnt); depth.store(fnc);			
			shot_cnt++;
		}
		if (keys.data[119+KEY_DOWN]) //wireframe
			if (modes[0]) {
  			modes[0]=false;
  			glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  		} else {
    		modes[0]=true;
    		glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    	};
	}
	glFlush();
	glutSwapBuffers();
	memset(&keys.data[KEY_ST+KEY_DOWN],0,1024); //what is this?!
	memset(&keys.data[KEY_SP+KEY_DOWN],0,1024);
};

void redisplay(void) {
  glutPostRedisplay();
}

void keyboard(unsigned char key,int x,int y) {	
	int m=glutGetModifiers();	
	keys.data[key+KEY_ST]=1;
	keys.data[key+KEY_ST+KEY_DOWN]=1;
	keys.data[key+KEY_MODIFY]=m;		
	printf("down %i %i\n",key,m);
};
void keyboardUp(unsigned char key,int x,int y) {	
	if (key==27) exit(0);	
	keys.data[key+KEY_ST]=0;
	keys.data[key+KEY_MODIFY]=0;	
};
void special(int key,int x,int y) {	
	int m=glutGetModifiers();
	keys.data[key+KEY_SP]=1;
	keys.data[key+KEY_SP+KEY_DOWN]=1;
	keys.data[key+KEY_SP+KEY_MODIFY]=m;	
	printf("spec %i %i\n",key,m);
};
void specialUp(int key,int x,int y) {
	keys.data[key+KEY_SP]=0;
	keys.data[key+KEY_SP+KEY_MODIFY]=0;
};
void mousefunc(int b,int s,int x,int y) {
	int c1;
	if (b==0)
		if (s==0)	{
			mouse[0]=0; //delta
			mouse[1]=0;
			mouse[2]=y; //actual
			mouse[3]=x;
			mouse[4]=y; //mouse offset
			mouse[5]=x;
			mouse[6]=1;}
		else
			for (c1=0;c1<7;c1++) mouse[c1]=0;
};
void motion(int x,int y) {	
	if (mouse[6]) {
		mouse[0]=y-mouse[2];
		mouse[1]=x-mouse[3];
		mouse[2]=y;
		mouse[3]=x;};
};

void passivemotion(int x,int y) {
}

void entry(int s) {
#ifndef RELEASE_MODE
	//if (!s) exit(0);
#endif
};
void reshape(int framew,int frameh) {	
	float p[16];
	frame_w =framew;		frame_h =frameh;	
	frame_w2=framew*.5; frame_h2=frameh*.5;
	glViewport (0,0,frame_w,frame_h);
	glMatrixMode(GL_PROJECTION);						//matrices
		glLoadIdentity();
		gluPerspective(55,frame_w/(float)frame_h,.1,FRUSTUM);
		glGetFloatv(GL_PROJECTION_MATRIX,p);
		memcpy(project.data,p,4*16);		
	display();
}

int main(int argc,char** argv) {
	int c1;	
	//for (c1=0;c1<argc;c1++)
	//  printf("%i = %s\n",c1,argv[c1]);
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH|GLUT_RGBA);	
	//glutInitDisplayMode(GLUT_SINGLE | GLUT_DEPTH|GLUT_RGBA);	
	if (!fscreen) {
		glutInitWindowPosition(730,30);
		glutInitWindowSize(frame_w,frame_h);		
		glutCreateWindow("virtual world");
	} else {
		glutGameModeString("1152x864:32@75");
		if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) glutEnterGameMode();
	}	
	glutDisplayFunc(display);								//callbacks
		glutIdleFunc(redisplay);
		glutKeyboardFunc(keyboard);
		glutKeyboardUpFunc(keyboardUp);
		glutSpecialFunc(special);
		glutSpecialUpFunc(specialUp);
		glutMouseFunc(mousefunc);
		glutMotionFunc(motion);
		glutPassiveMotionFunc(passivemotion);
		glutEntryFunc(entry);
		glutReshapeFunc(reshape);
		glutIgnoreKeyRepeat(1);	
	glMatrixMode(GL_PROJECTION);						//matrices
		gluPerspective(55,1.5,.1,FRUSTUM);				
	glClearColor(0,0,0,0);								//background
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);     //texture
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);		
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);		
	glDisable(GL_BLEND);										//blending
	for (c1=0;c1<7;c1++)
	  mouse[c1]=0;
	fnt0=new array<unsigned char>("data/courier.fnt");	
	main_(argc,argv);
	timer::singleton()->resetTime(1);
	glutMainLoop();
	return 0;
}

// utility functions related to OpenGL stuff

void loadTex(GLuint hnd,char *fn) {
	array<unsigned char> tex(fn);
	glBindTexture(GL_TEXTURE_2D,hnd);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA,tex.size[1],tex.size[2],GL_RGBA,GL_UNSIGNED_BYTE,tex.data);
	//glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,tex.size[1],tex.size[2],0,GL_RGBA,GL_UNSIGNED_BYTE,tex.data);
};

unsigned int jGenList(array<float> *arr,array<unsigned int> *ind,unsigned int tex) {
	int c1,cnt=0;
	unsigned int list=0,hnd=glGenLists(1);
	if (arr->size[0]== 6) list=GL_C3F_V3F;
	if (arr->size[0]== 8) list=GL_T2F_N3F_V3F;
	if (arr->size[0]==10) list=GL_C4F_N3F_V3F;
	glNewList(hnd,GL_COMPILE);
		glColor4f(1,1,1,1);
		glNormal3f(0,1,0);
		glInterleavedArrays(list,0,arr->data);
		if (tex) {
  		glEnable(GL_TEXTURE_2D);
  		glBindTexture(GL_TEXTURE_2D,tex);
  	}
		if      (ind->size[0]==2) //GL_QUAD_STRIP
			for (c1=0;c1<arr->size[2]-1;c1++)
				glDrawElements(GL_QUAD_STRIP,2*arr->size[1],GL_UNSIGNED_INT,&ind->data[c1*2*arr->size[1]]);
		else if (ind->size[0]==3) //GL_TRIANGLES
			glDrawElements(GL_TRIANGLES,ind->numel,GL_UNSIGNED_INT,ind->data);
		if (tex)
		  glDisable(GL_TEXTURE_2D);
	glEndList();
	cout << " \\- drawlist: #" << hnd << " tex:" << tex << " list:" << list << endl;
	return hnd;	
}

void jDrawA6T6I3(array<float> *arr,array<float> *tx2,array<unsigned int> *ind,unsigned int tex) {	
	int c1,c2=0,c3=0;
	if (tex) {glEnable(GL_TEXTURE_2D); glBindTexture(GL_TEXTURE_2D,tex); }
	glBegin(GL_TRIANGLES);
		glColor4f(1,1,1,1);
		for (c1=0;c1<ind->numel;c1++) {
			c3=ind->data[c1]*6; //make T = T*6 => faster!!!
			glTexCoord2fv(&tx2->data[c2]);
			glNormal3fv(&arr->data[c3]);
			glVertex3fv(&arr->data[c3+3]);
			c2+=2;
		}
	glEnd();
	if (tex) glDisable(GL_TEXTURE_2D);
}

unsigned int newList(char *fn,unsigned int tex) {		
	//change mat to *mat an accept NULL for ID Matrix so dont push
	int c1,cnt=0;	
	char fnc[80];
	sprintf(fnc,"%s.arr",fn); array<float>				arr(fnc);
	sprintf(fnc,"%s.ind",fn); array<unsigned int> ind(fnc);	
	return jGenList(&arr,&ind,tex);
}

void glPlotNormals(array<float> *v) {
	matrix<float> ver(3,1,"");
	matrix<float> nrm(3,1,"");	
	glLineWidth(1);
	glColor3f(0,0,0);
	glBegin(GL_LINES);
	for (int c1=0;c1<v->size[1];c1++) {				
		memcpy(nrm.data,&v->data[10*c1+4],12);
		memcpy(ver.data,&v->data[10*c1+7],12);
		ver+=nrm;
		glVertex3fv(ver.data);
		glVertex3fv(nrm.data);
	}
	glEnd();
}
